/*
** program 3
** Topics in C programming, p 369
*/

#include "curses.h"
#include <stdlib.h>

void main( void )
{
	char ch;
	chtype in;
	short wx, wy;
	int i;
	WINDOW *errwin;

	/* initial setup of curses */
	initscr();
	cbreak();
	noecho();
	nonl();

	/* set up error window */
	errwin = newwin( 6, 30, LINES / 2 - 3, COLS / 2 - 15 );
	box( errwin, 0, 0 );
	wstandout( errwin );
	mvwprintw( errwin, 2, 6, "Error in user input" );
	wstandend( errwin );
	mvwprintw( errwin, 3, 4, "Hit any key to continue" );
	getyx( errwin, wy, wx );

	/* set up stdscr */
	for ( i = 0; i < LINES; ++i )
		mvprintw( i, i, "This is just junk on line %d", i );
	nodelay( errwin, TRUE );

	for( ; ; )
	{
		refresh();

		/* get command and process */
		in = getch();
		switch( in )
		{
			case 'q':
				endwin();
				exit( 0 );

			default:
				touchwin( errwin );
				wrefresh( errwin );

				i = 0;
				ch = mvwinch( errwin, wy, wx );
				mvwaddch( errwin, wy, wx, '#' );
				wrefresh( errwin );
				do
				{
					if ( ++i == 500 )
					{
						mvwaddch( errwin, wy, wx, ch );
						wrefresh( errwin );
					}
					else if ( i == 1000 )
					{
						mvwaddch( errwin, wy, wx, '#' );
						wrefresh( errwin );
						i = 0;
					}
					in = wgetch( errwin );
				} while ( in == -1 );

				touchwin( stdscr );
				break;
		}
	}
}
