/*
** ochars.h
**
** Omega/curses expanded character set
*/

/*
**     A---E---B
**     |       |
**     |       |
**     F       G
**     |       |
**     |       |
**     C---H---D
*/

/* Pools of water */
#define POOL_WHOLE	0xa0
#define POOL_A		0xa1
#define POOL_B		0xa2
#define POOL_C		0xa3
#define POOL_D		0xa4
#define POOL_AB		0xa5
#define POOL_CD		0xa6
#define POOL_AC		0xa7
#define POOL_BD		0xa8
#define POOL_BC		0xa9
#define POOL_AD		0xaa
#define POOL_ABC	0xab
#define POOL_ABD	0xac
#define POOL_ACD	0xad
#define POOL_BCD	0xae
#define POOL_ABCD	0xaf
#define POOL_E		0xb0
#define POOL_H		0xb1
#define POOL_F		0xb2
#define POOL_G		0xb3
#define POOL_CE		0xb4
#define POOL_DE		0xb5
#define POOL_AH		0xb6
#define POOL_BH		0xb7
#define POOL_CDE	0xb8
#define POOL_ABH	0xb9
#define POOL_BF		0xba
#define POOL_DF		0xbb
#define POOL_AG		0xbc
#define POOL_CG		0xbd
#define POOL_BDF	0xbe
#define POOL_ACG	0xbf
#define POOL_EF		0xc0
#define POOL_EG		0xc1
#define POOL_FH		0xc2
#define POOL_GH		0xc3
#define POOL_EH		0xc4
#define POOL_FG		0xc5
#define POOL_DEF	0xc6
#define POOL_CEG	0xc7
#define POOL_BFH	0xc8
#define POOL_AGH	0xc9
#define POOL_EFH	0xca
#define POOL_EGH	0xcb
#define POOL_EFG	0xcc
#define POOL_FGH	0xcd
#define POOL_EFGH	0xce

#define POOL_FIRST	0xa0
#define POOL_LAST	0xce

#define MY_RUBBLE	0xcf

/* Walls */
#define WALL_WHOLE	0xd0
#define WALL_A		0xd1
#define WALL_B		0xd2
#define WALL_C		0xd3
#define WALL_D		0xd4
#define WALL_AB		0xd5
#define WALL_CD		0xd6
#define WALL_AC		0xd7
#define WALL_BD		0xd8
#define WALL_BC		0xd9
#define WALL_AD		0xda
#define WALL_ABC	0xdb
#define WALL_ABD	0xdc
#define WALL_ACD	0xdd
#define WALL_BCD	0xde
#define WALL_ABCD	0xdf
#define WALL_E		0xe0
#define WALL_H		0xe1
#define WALL_F		0xe2
#define WALL_G		0xe3
#define WALL_CE		0xe4
#define WALL_DE		0xe5
#define WALL_AH		0xe6
#define WALL_BH		0xe7
#define WALL_CDE	0xe8
#define WALL_ABH	0xe9
#define WALL_BF		0xea
#define WALL_DF		0xeb
#define WALL_AG		0xec
#define WALL_CG		0xed
#define WALL_BDF	0xee
#define WALL_ACG	0xef
#define WALL_EF		0xf0
#define WALL_EG		0xf1
#define WALL_FH		0xf2
#define WALL_GH		0xf3
#define WALL_EH		0xf4
#define WALL_FG		0xf5
#define WALL_DEF	0xf6
#define WALL_CEG	0xf7
#define WALL_BFH	0xf8
#define WALL_AGH	0xf9
#define WALL_EFH	0xfa
#define WALL_EGH	0xfb
#define WALL_EFG	0xfc
#define WALL_FGH	0xfd
#define WALL_EFGH	0xfe

#define WALL_FIRST	0xd0
#define WALL_LAST	0xfe

#define MY_ABYSS	0xff

/* Hedges */
#define HEDGE_WHOLE	0x100
#define HEDGE_A		0x101
#define HEDGE_B		0x102
#define HEDGE_C		0x103
#define HEDGE_D		0x104
#define HEDGE_AB	0x105
#define HEDGE_CD	0x106
#define HEDGE_AC	0x107
#define HEDGE_BD	0x108
#define HEDGE_BC	0x109
#define HEDGE_AD	0x10a
#define HEDGE_ABC	0x10b
#define HEDGE_ABD	0x10c
#define HEDGE_ACD	0x10d
#define HEDGE_BCD	0x10e
#define HEDGE_ABCD	0x10f
#define HEDGE_E		0x110
#define HEDGE_H		0x111
#define HEDGE_F		0x112
#define HEDGE_G		0x113
#define HEDGE_CE	0x114
#define HEDGE_DE	0x115
#define HEDGE_AH	0x116
#define HEDGE_BH	0x117
#define HEDGE_CDE	0x118
#define HEDGE_ABH	0x119
#define HEDGE_BF	0x11a
#define HEDGE_DF	0x11b
#define HEDGE_AG	0x11c
#define HEDGE_CG	0x11d
#define HEDGE_BDF	0x11e
#define HEDGE_ACG	0x11f
#define HEDGE_EF	0x120
#define HEDGE_EG	0x121
#define HEDGE_FH	0x122
#define HEDGE_GH	0x123
#define HEDGE_EH	0x124
#define HEDGE_FG	0x125
#define HEDGE_DEF	0x126
#define HEDGE_CEG	0x127
#define HEDGE_BFH	0x128
#define HEDGE_AGH	0x129
#define HEDGE_EFH	0x12a
#define HEDGE_EGH	0x12b
#define HEDGE_EFG	0x12c
#define HEDGE_FGH	0x12d
#define HEDGE_EFGH	0x12e

#define HEDGE_FIRST	0x100
#define HEDGE_LAST	0x12e

#define MY_VOID		0x12f

/* Altars */
#define ALTAR_HECATE	0x130
#define ALTAR_ODIN		0x131
#define ALTAR_DESTINY	0x132
#define ALTAR_SET		0x133
#define ALTAR_ATHENA	0x134
#define ALTAR_DRUID		0x135
#define ALTAR_UNKNOWN	0x136

#define ALTAR_FIRST		0x130
#define ALTAR_LAST		0x136

/* some miscellaneous city/dungeon/village stuff */
#define MY_LAVA			0x137
#define MY_STAIRS_DOWN	0x138
#define MY_STAIRS_UP	0x139
#define MY_SAFE			0x13a
#define MY_STATUE		0x13b
#define MY_LIFT			0x13c
#define MY_FIRE			0x13d
#define MY_WHIRLWIND	0x13e
#define MY_STONE		0x13f
#define V_GROOVE		0x140
#define H_GROOVE		0x141
#define H_PORTCULLIS	0x142
#define V_PORTCULLIS	0x143
#define MY_CLOSED_DOOR	0x144
#define MY_OPEN_DOOR	0x145

/* ground spaces */
#define GROUND			0x146
#define GROUND_CLEARED	0x147

#define GROUND_FIRST	0x146
#define GROUND_LAST		0x147

#define C_CHAIR			0x148

/* Monsters */

#define C_HORNET		0x150
#define C_PRIEST		0x151
#define C_MERCHANT		0x152
#define C_GUARD			0x153
#define C_HUMAN			0x154
#define C_SHEEP			0x155
#define C_GRUNT			0x156
#define C_FLY			0x157
#define C_FNORD			0x158
#define C_RAT			0x159
#define C_AGFUNGUS		0x15a
#define C_BLIPPER		0x15b
#define C_GOBLIN		0x15c
#define C_PHANTASTICON	0x15d
#define C_ROBOT			0x15e
#define C_GEEK			0x15f
#define C_BOROGROVE		0x160
#define C_QUAIL			0x161
#define C_BADGER		0x162
#define C_HAWK			0x163
#define C_DEER			0x164
#define C_CAMEL			0x165
#define C_ANTEATER		0x166
#define C_RABBIT		0x167
#define C_TROUT			0x168
#define C_BASS			0x169
#define C_PARROT		0x16a
#define C_HYENA			0x16b
#define C_NINJA			0x16c
#define C_NGAUNT		0x16d
#define C_EYE			0x16e
#define C_TOVE			0x16f
#define C_TNASTY		0x170
#define C_GHOST			0x171
#define C_ENCHANT		0x172
#define C_MFUNGUS		0x173
#define C_HGOBLIN		0x174
#define C_WOLF			0x175
#define C_ANT			0x176
#define C_ELEPHANT		0x177
#define C_HORSE			0x178
#define C_SALAMANDER	0x179
#define C_CATOBLEPAS	0x17a
#define C_LFDEMON		0x17b
#define C_ACID			0x17c
#define C_PHANTOM		0x17d
#define C_GOBKING		0x17e
#define C_PTERODACTYL	0x17f
#define C_LION			0x180
#define C_BRIGAND		0x181
#define C_BEAR			0x182
#define C_MAMBA			0x183
#define C_MANOWAR		0x184
#define C_THOUGHTFORM	0x185
#define C_MANTICORE		0x186
#define C_TDEVIL		0x187
#define C_AUTOMINOR		0x188
#define C_DENEBIANSD	0x189
#define C_JUBJUB		0x18a
#define C_HAUNT			0x18b
#define C_INCUBUS		0x18c
#define C_SUCCUBUS		0x18d
#define C_SATYR			0x18e
#define C_NYMPH			0x18f
#define C_CROC			0x190
#define C_TORPOR		0x191
#define C_DOBERMAN		0x192
#define C_AFUZZY		0x193
#define C_LSERVANT		0x194
#define C_CSERVANT		0x195
#define C_SWARM			0x196
#define C_BANSIDHE		0x197
#define C_EGRUE			0x198
#define C_DRAGONETTE	0x199
#define C_TESLA			0x19a
#define C_WYVERN		0x19b
#define C_RCATEAGLE		0x19c
#define C_FDEMON		0x19d
#define C_SPECTRE		0x19e
#define C_NECROMANCER	0x19f
#define C_SSPIRIT		0x1a0
#define C_BOGTHING		0x1a1
#define C_AVAMPIRE		0x1a2
#define C_LAVAWORM		0x1a3
#define C_MANABURST		0x1a4
#define C_OCDEMON		0x1a5
#define C_MSHADE		0x1a6
#define C_FELEMENTAL	0x1a7
#define C_AELEMENTAL	0x1a8
#define C_WELEMENTAL	0x1a9
#define C_EELEMENTAL	0x1aa
#define C_BANDER		0x1ab
#define C_LICH			0x1ac
#define C_TRITON		0x1ad
#define C_TRICERA		0x1ae
#define C_RAKSHASA		0x1af
#define	C_DSERPENT		0x1b0
#define C_ANGEL			0x1b1
#define C_BEHEMOTH		0x1b2
#define C_NAZGUL		0x1b3
#define C_UNICORN		0x1b4
#define C_ROUS			0x1b5
#define C_ILFIEND		0x1b6
#define C_GWYRM			0x1b7
#define C_FDEVIL		0x1b8
#define C_LURKER		0x1b9
#define C_SANDMAN		0x1ba
#define C_MMASTER		0x1bb
#define C_ELDEGRUE		0x1bc
#define C_LSERPENT		0x1bd
#define C_ZOVERLORD		0x1be
#define C_RICOCHET		0x1bf
#define C_ICDEMON		0x1c0
#define C_FAIRY			0x1c1
#define C_AUTOMAJOR		0x1c2
#define C_DRAGON		0x1c3
#define C_JABBER		0x1c4
#define C_FDLORD		0x1c5
#define C_TSHARK		0x1c6
#define C_SSLAYER		0x1c7
#define C_COMABEAST		0x1c8
#define C_HIGHANGEL		0x1c9
#define C_JOTUN			0x1ca
#define C_ISLAYER		0x1cb
#define C_KWYVERN		0x1cc
#define C_DSTAR			0x1cd
#define C_HIGHTHAUM		0x1ce
#define C_VLORD			0x1cf
#define C_ARCHANGEL		0x1d0
#define C_DPRINCE		0x1d1
#define C_DEATH			0x1d2
#define C_EATER			0x1d3
#define C_LAWBRINGER	0x1d4
#define C_DRAGONLORD	0x1d5
#define C_DEMPEROR		0x1d6
#define C_EARTHLORD		0x1d7
#define C_AIRLORD		0x1d8
#define C_WATERLORD		0x1d9
#define C_FIRELORD		0x1da
#define C_ELEMASTER		0x1db

/* items, other tiles */
#define C_SCROLL		0x1dc
#define C_BOOK			0x1dd

#define TEXT_FIRST		0x1dc
#define TEXT_LAST		0x1dd

#define C_POTION		0x1de
#define C_SHIELD		0x1df
#define C_CLOAK			0x1e0

#define C_SWORD			0x1e1
#define C_RAPIER		0x1e2
#define C_DAGGER		0x1e3
#define C_SPEAR			0x1e4
#define C_AXE			0x1e5
#define C_MACE			0x1e6
#define C_TRIDENT		0x1e7
#define C_WHIP			0x1e8
#define C_SCYTHE		0x1e9
#define C_LSABRE		0x1ea
#define C_MSWORD		0x1eb
#define C_MAXE			0x1ec
#define C_MMACE			0x1ed
#define C_MSPEAR		0x1ee

#define WEAPON_FIRST	0x1e1
#define WEAPON_LAST		0x1ee

#define C_BOW			0x1ef
#define C_CROSSBOW		0x1f0
#define C_BOLA			0x1f1
#define C_ARROW			0x1f2

#define MISSILEW_FIRST	0x1ef
#define MISSILEW_LAST	0x1f2

#define C_RING			0x1f3
#define C_CROSS			0x1f4
#define C_TRAP			0x1f5
#define C_STICK			0x1f6

#define C_COPPERS		0x1f7
#define C_SILVERS		0x1f8
#define C_GOLDS			0x1f9
#define C_MITHRILS		0x1fa
#define C_ORICHALCS		0x1fb
#define C_GEMS			0x1fc

#define CASH_FIRST		0x1f7
#define CASH_LAST		0x1fc

#define C_BOOTS			0x1fd

#define C_ARMOR			0x1fe
#define C_THING			0x1ff
#define C_PLAYER		0x200

#define C_NBOLT			0x201
#define C_EBOLT			0x202
#define C_FBOLT			0x203

#define C_FBALL			0x204
#define C_SBALL			0x205
#define C_EBALL			0x206
#define C_MBALL			0x207

#define C_JUNK			0x208

#define C_OMASTERY		0x209
#define C_OFIRE			0x20a
#define C_OWATER		0x20b
#define C_OEARTH		0x20c
#define C_OAIR			0x20d
#define C_OBURNTOUT		0x20e
#define C_CRYSTALBALL	0x20f
#define C_GRENADE		0x210
#define C_AYENDOR		0x211
#define C_KOLWYNIA		0x212
#define C_PODEATH		0x213
#define C_SENCHANT		0x214
#define C_TELEHELM		0x215
#define C_POLIFE		0x216
#define C_HSODIN		0x217
#define C_HSSET			0x218
#define C_HSATHENA		0x219
#define C_HSHECATE		0x21a
#define C_HSDRUID		0x21b
#define C_HSDESTINY		0x21c
#define C_JUGGERNAUT	0x21d
#define C_STARGEM		0x21e
#define C_SCEPTRE		0x21f
#define C_APLANES		0x220

#define ARTIFACT_FIRST	0x209
#define ARTIFACT_LAST	0x220

#define C_RATION		0x221
#define C_LEMBAS		0x222
#define C_TABLET		0x223
#define C_JELLYBABY		0x224
#define C_PEPPER		0x225
#define C_PIZZA			0x226
#define C_HUNAN			0x227
#define C_TWINKIES		0x228
#define C_CHDOODLE		0x229
#define C_PTWIRL		0x22a
#define C_VEALP			0x22b
#define C_GRAIN			0x22c

#define FOOD_FIRST		0x221
#define FOOD_LAST		0x22c

#define MTN_WHOLE		0x240
#define MTN_TP_LP		0x245	/* Top & left sides plain */
#define MTN_BF			0x2b0	/* Bottom side plain */
#define MTN_LP			0x241	/* Left side plain */
#define MTN_URF_LRP		0x2ae	/* Upper right corner forest, lower right corner plain */
#define MTN_TF_RF_BP	0x2ac	/* Top & right sides forest, bottom side plain */
#define MTN_ULR_LRR		0x2fe	/* Upper left corner & lower right corner river */
#define MTN_LRP			0x261
#define MTN_BP			0x244
#define MTN_ULP			0x263
#define MTN_TP			0x243
#define MTN_ULP_LLP		0x265
#define MTN_ULS_LLS_URS_LRS	0x317
#define MTN_LD			0x271

#define MTN_ULPS_LRP	0x2ec	/* Upper left corner pass, Lower right corner plain */
#define MTN_ULPS_LLPS_BP	0x2ed
#define MTN_LRPS		0x2ee	/* Lower right corner pass */
#define MTN_LLPS		0x2ef	/* Lower left corner pass */
#define MTN_URPS		0x2f0	/* Upper right corner pass */
#define MTN_URPS_LRPS	0x2f1	/* Upper right and lower right corners pass */
#define MTN_URPS_ULP	0x2f2
#define MTN_URPS_BF		0x2f3
#define MTN_LLPS_TP		0x2f4

#define MTN_PTIP		0x2ff	/* tip of peninsula where star peak is */
#define MTN_LLRD_BP		0x330

#define MTN_FIRST		0x240
#define MTN_LAST		0x33f

#define SWAMP_ISLE		0x362	/* location of magic isle */

#define SWAMP_FIRST		0x340
#define SWAMP_LAST		0x367

#define DESERT_FIRST	0x368
#define DESERT_LAST		0x36f

#define FOREST_FIRST	0x370
#define FOREST_LAST		0x3af

#define PLAINS_FIRST	0x3b0
#define PLAINS_LAST		0x3bf

#define RIVER_FIRST		0x3c0
#define RIVER_LAST		0x44f

#define PASS_UL_PLAIN	0x450
#define PASS_ULTOLR		0x451
#define PASS_LR_FOREST	0x452
#define PASS_L_PLAIN	0x453
#define PASS_LTOR		0x454
#define PASS_R_FOREST	0x455
#define PASS_ULTOLL		0x456
#define PASS_LLTOUR		0x457
#define PASS_PENIN		0x458

#define PASS_FIRST		0x450
#define PASS_LAST		0x45f

#define ROAD_FIRST		0x460
#define ROAD_LAST		0x49f

#define SEA_FIRST		0x4a0
#define SEA_LAST		0x4c7

#define JUNGLE_FIRST	0x4e0
#define JUNGLE_LAST		0x51f

#define BANKCHAR_OFFSET 0x500

#define C_RAMPART		0x4c8
#define C_WOODMERE		0x4c9
#define C_SKORCH		0x4ca
#define C_THAUM_HP		0x4cb
#define C_THAUMARIS		0x4cc
#define C_STARVIEW		0x4cd
#define C_WHORFEN		0x4ce
#define C_STORMWATCH	0x4cf

#define VILLAGE_FIRST	0x4c9
#define VILLAGE_LAST	0x4cf

#define C_DRUID			0x4d0
#define C_ATHENA		0x4d1
#define C_ODIN			0x4d2
#define C_SET			0x4d3
#define C_HECATE		0x4d4
#define C_DESTINY		0x4d5

#define TEMPLE_FIRST	0x4d0
#define TEMPLE_LAST		0x4d5

#define C_CASTLE		0x4d6
#define C_STARPEAK		0x4d7
#define C_CAVES			0x4d8
#define C_VOLCANO		0x4d9
#define C_DRAGONLAIR	0x4da
#define C_MAGICISLE		0x4db

#define WALL_DIAG_FIRST				0x301
#define WALL_DIAG_LAST				0x300

